Package: io.vertx.groovy.core.http

## [Groovy] Class HttpClient

- io.vertx.groovy.core.http.HttpClient

- All Implemented Interfaces and Traits:
    Measured

      @groovy.transform.CompileStatic
      class HttpClient
      extends java.lang.Object

  An asynchronous HTTP client.

  It allows you to make requests to HTTP servers, and a single client can make requests to any server.

  It also allows you to open WebSockets to servers.

  The client can also pool HTTP connections.

  For pooling to occur, keep-alive must be true on the HttpClientOptions (default is true). In this case connections will be pooled and re-used if there are pending HTTP requests waiting to get a connection, otherwise they will be closed.

  This gives the benefits of keep alive when the client is loaded but means we don't keep connections hanging around unnecessarily when there would be no benefits anyway.

  The client also supports pipe-lining of requests. Pipe-lining means another request is sent on the same connection before the response from the preceding one has returned. Pipe-lining is not appropriate for all requests.

  To enable pipe-lining, it must be enabled on the HttpClientOptions (default is false).

  When pipe-lining is enabled the connection will be automatically closed when all in-flight responses have returned and there are no outstanding pending requests to write.

  The client is designed to be reused between requests.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `HttpClient (java.lang.Object delegate)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `close()` Close the client.
    `HttpClientRequest` | `delete(int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP DELETE request to send to the server at the specified host and port.
    `HttpClientRequest` | `delete(java.lang.String host, java.lang.String requestURI)` Create an HTTP DELETE request to send to the server at the specified host and default port.
    `HttpClientRequest` | `delete(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP DELETE request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `delete(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP DELETE request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `delete(java.lang.String requestURI)` Create an HTTP DELETE request to send to the server at the default host and port.
    `HttpClientRequest` | `delete(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP DELETE request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `deleteAbs(java.lang.String absoluteURI)` Create an HTTP DELETE request to send to the server using an absolute URI
    `HttpClientRequest` | `deleteAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP DELETE request to send to the server using an absolute URI, specifying a response handler to receive the response
    `HttpClientRequest` | `get(int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP GET request to send to the server at the specified host and port.
    `HttpClientRequest` | `get(java.lang.String host, java.lang.String requestURI)` Create an HTTP GET request to send to the server at the specified host and default port.
    `HttpClientRequest` | `get(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP GET request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `get(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP GET request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `get(java.lang.String requestURI)` Create an HTTP GET request to send to the server at the default host and port.
    `HttpClientRequest` | `get(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP GET request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `getAbs(java.lang.String absoluteURI)` Create an HTTP GET request to send to the server using an absolute URI
    `HttpClientRequest` | `getAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP GET request to send to the server using an absolute URI, specifying a response handler to receive the response
    `java.lang.Object` | `getDelegate()`
    `HttpClient` | `getNow(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP GET request to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClient` | `getNow(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP GET request to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClient` | `getNow(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP GET request to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `head(int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP HEAD request to send to the server at the specified host and port.
    `HttpClientRequest` | `head(java.lang.String host, java.lang.String requestURI)` Create an HTTP HEAD request to send to the server at the specified host and default port.
    `HttpClientRequest` | `head(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP HEAD request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `head(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP HEAD request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `head(java.lang.String requestURI)` Create an HTTP HEAD request to send to the server at the default host and port.
    `HttpClientRequest` | `head(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP HEAD request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `headAbs(java.lang.String absoluteURI)` Create an HTTP HEAD request to send to the server using an absolute URI
    `HttpClientRequest` | `headAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP HEAD request to send to the server using an absolute URI, specifying a response handler to receive the response
    `HttpClient` | `headNow(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP HEAD request to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClient` | `headNow(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP HEAD request to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClient` | `headNow(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP HEAD request to the server at the default host and port, specifying a response handler to receive the response
    `boolean` | `isMetricsEnabled()` Whether the metrics are enabled for this measured object
    `HttpClientRequest` | `options(int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP OPTIONS request to send to the server at the specified host and port.
    `HttpClientRequest` | `options(java.lang.String host, java.lang.String requestURI)` Create an HTTP OPTIONS request to send to the server at the specified host and default port.
    `HttpClientRequest` | `options(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP OPTIONS request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `options(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP OPTIONS request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `options(java.lang.String requestURI)` Create an HTTP OPTIONS request to send to the server at the default host and port.
    `HttpClientRequest` | `options(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP OPTIONS request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `optionsAbs(java.lang.String absoluteURI)` Create an HTTP OPTIONS request to send to the server using an absolute URI
    `HttpClientRequest` | `optionsAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP OPTIONS request to send to the server using an absolute URI, specifying a response handler to receive the response
    `HttpClient` | `optionsNow(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP OPTIONS request to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClient` | `optionsNow(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP OPTIONS request to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClient` | `optionsNow(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Sends an HTTP OPTIONS request to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `post(int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP POST request to send to the server at the specified host and port.
    `HttpClientRequest` | `post(java.lang.String host, java.lang.String requestURI)` Create an HTTP POST request to send to the server at the specified host and default port.
    `HttpClientRequest` | `post(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP POST request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `post(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP POST request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `post(java.lang.String requestURI)` Create an HTTP POST request to send to the server at the default host and port.
    `HttpClientRequest` | `post(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP POST request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `postAbs(java.lang.String absoluteURI)` Create an HTTP POST request to send to the server using an absolute URI
    `HttpClientRequest` | `postAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP POST request to send to the server using an absolute URI, specifying a response handler to receive the response
    `HttpClientRequest` | `put(int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP PUT request to send to the server at the specified host and port.
    `HttpClientRequest` | `put(java.lang.String host, java.lang.String requestURI)` Create an HTTP PUT request to send to the server at the specified host and default port.
    `HttpClientRequest` | `put(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP PUT request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `put(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP PUT request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `put(java.lang.String requestURI)` Create an HTTP PUT request to send to the server at the default host and port.
    `HttpClientRequest` | `put(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP PUT request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `putAbs(java.lang.String absoluteURI)` Create an HTTP PUT request to send to the server using an absolute URI
    `HttpClientRequest` | `putAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP PUT request to send to the server using an absolute URI, specifying a response handler to receive the response
    `HttpClientRequest` | `request(io.vertx.core.http.HttpMethod method, int port, java.lang.String host, java.lang.String requestURI)` Create an HTTP request to send to the server at the specified host and port.
    `HttpClientRequest` | `request(io.vertx.core.http.HttpMethod method, java.lang.String host, java.lang.String requestURI)` Create an HTTP request to send to the server at the specified host and default port.
    `HttpClientRequest` | `request(io.vertx.core.http.HttpMethod method, int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP request to send to the server at the specified host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `request(io.vertx.core.http.HttpMethod method, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP request to send to the server at the specified host and default port, specifying a response handler to receive the response
    `HttpClientRequest` | `request(io.vertx.core.http.HttpMethod method, java.lang.String requestURI)` Create an HTTP request to send to the server at the default host and port.
    `HttpClientRequest` | `request(io.vertx.core.http.HttpMethod method, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP request to send to the server at the default host and port, specifying a response handler to receive the response
    `HttpClientRequest` | `requestAbs(io.vertx.core.http.HttpMethod method, java.lang.String absoluteURI)` Create an HTTP request to send to the server using an absolute URI
    `HttpClientRequest` | `requestAbs(io.vertx.core.http.HttpMethod method, java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)` Create an HTTP request to send to the server using an absolute URI, specifying a response handler to receive the response
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified port, host and relative request URI
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified port, host and relative request URI
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the host and relative request URI and default port
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the host and relative request URI and default port
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified port, host and relative request URI, and with the specified headers
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified port, host and relative request URI, and with the specified headers
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified host,relative request UR, and default port and with the specified headers
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified host,relative request UR, and default port and with the specified headers
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified port, host and relative request URI, with the specified headers and using the specified version of WebSockets
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified port, host and relative request URI, with the specified headers and using the specified version of WebSockets
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified host, relative request URI and default port with the specified headers and using the specified version of WebSockets
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified host, relative request URI and default port with the specified headers and using the specified version of WebSockets
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified port, host and relative request URI, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols
    `HttpClient` | `websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified port, host and relative request URI, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket to the specified host, relative request URI and default port, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols
    `HttpClient` | `websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket to the specified host, relative request URI and default port, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols
    `HttpClient` | `websocket(java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket at the relative request URI using the default host and port
    `HttpClient` | `websocket(java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket at the relative request URI using the default host and port
    `HttpClient` | `websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket at the relative request URI using the default host and port and the specified headers
    `HttpClient` | `websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket at the relative request URI using the default host and port and the specified headers
    `HttpClient` | `websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket at the relative request URI using the default host and port, the specified headers and the specified version of WebSockets
    `HttpClient` | `websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket at the relative request URI using the default host and port, the specified headers and the specified version of WebSockets
    `HttpClient` | `websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect)` Connect a WebSocket at the relative request URI using the default host and port, the specified headers, the specified version of WebSockets and the specified sub protocols
    `HttpClient` | `websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)` Connect a WebSocket at the relative request URI using the default host and port, the specified headers, the specified version of WebSockets and the specified sub protocols
    `WebSocketStream` | `websocketStream(int port, java.lang.String host, java.lang.String requestURI)` Create a WebSocket stream to the specified port, host and relative request URI
    `WebSocketStream` | `websocketStream(java.lang.String host, java.lang.String requestURI)` Create a WebSocket stream to the specified host, relative request URI and default port
    `WebSocketStream` | `websocketStream(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers)` Create a WebSocket stream to the specified port, host and relative request URI, and with the specified headers
    `WebSocketStream` | `websocketStream(java.lang.String host, java.lang.String requestURI, MultiMap headers)` Create a WebSocket stream to the specified host, relative request URI and default port and with the specified headers
    `WebSocketStream` | `websocketStream(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version)` Create a WebSocket stream to the specified port, host and relative request URI, with the specified headers and using the specified version of WebSockets
    `WebSocketStream` | `websocketStream(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version)` Create a WebSocket stream to the specified host, relative request URI and default port and with the specified headers and using the specified version of WebSockets
    `WebSocketStream` | `websocketStream(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols)` Create a WebSocket stream to the specified port, host and relative request URI, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols
    `WebSocketStream` | `websocketStream(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols)` Create a WebSocket stream to the specified host, relative request URI and default port, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols
    `WebSocketStream` | `websocketStream(java.lang.String requestURI)` Create a WebSocket stream at the relative request URI using the default host and port and the specified headers
    `WebSocketStream` | `websocketStream(java.lang.String requestURI, MultiMap headers)` Create a WebSocket stream at the relative request URI using the default host and port and the specified headers
    `WebSocketStream` | `websocketStream(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version)` Create a WebSocket stream at the relative request URI using the default host and port, the specified headers and the specified version of WebSockets
    `WebSocketStream` | `websocketStream(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols)` Create a WebSocket stream at the relative request URI using the default host and port, the specified headers, the specified version of WebSockets and the specified sub protocols

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### HttpClient(java.lang.Object delegate)

  - ### Method Detail

    - #### void close()

      Close the client. Closing will close down any pooled connections. Clients should always be closed after use.

    - #### HttpClientRequest delete(int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP DELETE request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest delete(java.lang.String host, java.lang.String requestURI)

      Create an HTTP DELETE request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest delete(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP DELETE request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest delete(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP DELETE request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest delete(java.lang.String requestURI)

      Create an HTTP DELETE request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI

    - #### HttpClientRequest delete(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP DELETE request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest deleteAbs(java.lang.String absoluteURI)

      Create an HTTP DELETE request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest deleteAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP DELETE request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### HttpClientRequest get(int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP GET request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest get(java.lang.String host, java.lang.String requestURI)

      Create an HTTP GET request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest get(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP GET request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest get(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP GET request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest get(java.lang.String requestURI)

      Create an HTTP GET request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI

    - #### HttpClientRequest get(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP GET request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest getAbs(java.lang.String absoluteURI)

      Create an HTTP GET request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest getAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP GET request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### java.lang.Object getDelegate()

    - #### HttpClient getNow(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP GET request to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClient getNow(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP GET request to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClient getNow(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP GET request to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest head(int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP HEAD request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest head(java.lang.String host, java.lang.String requestURI)

      Create an HTTP HEAD request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest head(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP HEAD request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest head(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP HEAD request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest head(java.lang.String requestURI)

      Create an HTTP HEAD request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI

    - #### HttpClientRequest head(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP HEAD request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest headAbs(java.lang.String absoluteURI)

      Create an HTTP HEAD request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest headAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP HEAD request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### HttpClient headNow(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP HEAD request to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClient headNow(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP HEAD request to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClient headNow(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP HEAD request to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### boolean isMetricsEnabled()

      Whether the metrics are enabled for this measured object

      Returns:
        true if the metrics are enabled

    - #### HttpClientRequest options(int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP OPTIONS request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest options(java.lang.String host, java.lang.String requestURI)

      Create an HTTP OPTIONS request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest options(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP OPTIONS request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest options(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP OPTIONS request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest options(java.lang.String requestURI)

      Create an HTTP OPTIONS request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI

    - #### HttpClientRequest options(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP OPTIONS request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest optionsAbs(java.lang.String absoluteURI)

      Create an HTTP OPTIONS request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest optionsAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP OPTIONS request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### HttpClient optionsNow(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP OPTIONS request to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClient optionsNow(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP OPTIONS request to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClient optionsNow(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Sends an HTTP OPTIONS request to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest post(int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP POST request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest post(java.lang.String host, java.lang.String requestURI)

      Create an HTTP POST request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest post(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP POST request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest post(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP POST request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest post(java.lang.String requestURI)

      Create an HTTP POST request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI

    - #### HttpClientRequest post(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP POST request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest postAbs(java.lang.String absoluteURI)

      Create an HTTP POST request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest postAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP POST request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### HttpClientRequest put(int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP PUT request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest put(java.lang.String host, java.lang.String requestURI)

      Create an HTTP PUT request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest put(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP PUT request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest put(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP PUT request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest put(java.lang.String requestURI)

      Create an HTTP PUT request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI

    - #### HttpClientRequest put(java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP PUT request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest putAbs(java.lang.String absoluteURI)

      Create an HTTP PUT request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest putAbs(java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP PUT request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### HttpClientRequest request(io.vertx.core.http.HttpMethod method, int port, java.lang.String host, java.lang.String requestURI)

      Create an HTTP request to send to the server at the specified host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest request(io.vertx.core.http.HttpMethod method, java.lang.String host, java.lang.String requestURI)

      Create an HTTP request to send to the server at the specified host and default port.

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `host` - the host
        `requestURI` - the relative URI

    - #### HttpClientRequest request(io.vertx.core.http.HttpMethod method, int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP request to send to the server at the specified host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest request(io.vertx.core.http.HttpMethod method, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP request to send to the server at the specified host and default port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `host` - the host
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest request(io.vertx.core.http.HttpMethod method, java.lang.String requestURI)

      Create an HTTP request to send to the server at the default host and port.

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `requestURI` - the relative URI

    - #### HttpClientRequest request(io.vertx.core.http.HttpMethod method, java.lang.String requestURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP request to send to the server at the default host and port, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `requestURI` - the relative URI
        `responseHandler` - the response handler

    - #### HttpClientRequest requestAbs(io.vertx.core.http.HttpMethod method, java.lang.String absoluteURI)

      Create an HTTP request to send to the server using an absolute URI

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `absoluteURI` - the absolute URI

    - #### HttpClientRequest requestAbs(io.vertx.core.http.HttpMethod method, java.lang.String absoluteURI, io.vertx.core.Handler<HttpClientResponse> responseHandler)

      Create an HTTP request to send to the server using an absolute URI, specifying a response handler to receive the response

      Returns:
        an HTTP client request object
      Parameters:
        `method` - the HTTP method
        `absoluteURI` - the absolute URI
        `responseHandler` - the response handler

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified port, host and relative request URI

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified port, host and relative request URI

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the host and relative request URI and default port

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the host and relative request URI and default port

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified port, host and relative request URI, and with the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified port, host and relative request URI, and with the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified host,relative request UR, and default port and with the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified host,relative request UR, and default port and with the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified port, host and relative request URI, with the specified headers and using the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified port, host and relative request URI, with the specified headers and using the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified host, relative request URI and default port with the specified headers and using the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified host, relative request URI and default port with the specified headers and using the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified port, host and relative request URI, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols to use
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified port, host and relative request URI, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols to use
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket to the specified host, relative request URI and default port, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols to use
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket to the specified host, relative request URI and default port, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols to use
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket at the relative request URI using the default host and port

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String requestURI, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket at the relative request URI using the default host and port

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket at the relative request URI using the default host and port and the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket at the relative request URI using the default host and port and the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket at the relative request URI using the default host and port, the specified headers and the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket at the relative request URI using the default host and port, the specified headers and the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### HttpClient websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect)

      Connect a WebSocket at the relative request URI using the default host and port, the specified headers, the specified version of WebSockets and the specified sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols
        `wsConnect` - handler that will be called with the websocket when connected

    - #### HttpClient websocket(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols, io.vertx.core.Handler<WebSocket> wsConnect, io.vertx.core.Handler<java.lang.Throwable> failureHandler)

      Connect a WebSocket at the relative request URI using the default host and port, the specified headers, the specified version of WebSockets and the specified sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols
        `wsConnect` - handler that will be called with the websocket when connected
        `failureHandler` - handler that will be called if websocket connection fails

    - #### WebSocketStream websocketStream(int port, java.lang.String host, java.lang.String requestURI)

      Create a WebSocket stream to the specified port, host and relative request URI

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI

    - #### WebSocketStream websocketStream(java.lang.String host, java.lang.String requestURI)

      Create a WebSocket stream to the specified host, relative request URI and default port

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI

    - #### WebSocketStream websocketStream(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers)

      Create a WebSocket stream to the specified port, host and relative request URI, and with the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers

    - #### WebSocketStream websocketStream(java.lang.String host, java.lang.String requestURI, MultiMap headers)

      Create a WebSocket stream to the specified host, relative request URI and default port and with the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers

    - #### WebSocketStream websocketStream(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version)

      Create a WebSocket stream to the specified port, host and relative request URI, with the specified headers and using the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version

    - #### WebSocketStream websocketStream(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version)

      Create a WebSocket stream to the specified host, relative request URI and default port and with the specified headers and using the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version

    - #### WebSocketStream websocketStream(int port, java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols)

      Create a WebSocket stream to the specified port, host and relative request URI, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols to use

    - #### WebSocketStream websocketStream(java.lang.String host, java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols)

      Create a WebSocket stream to the specified host, relative request URI and default port, with the specified headers, using the specified version of WebSockets, and the specified websocket sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols to use

    - #### WebSocketStream websocketStream(java.lang.String requestURI)

      Create a WebSocket stream at the relative request URI using the default host and port and the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI

    - #### WebSocketStream websocketStream(java.lang.String requestURI, MultiMap headers)

      Create a WebSocket stream at the relative request URI using the default host and port and the specified headers

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers

    - #### WebSocketStream websocketStream(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version)

      Create a WebSocket stream at the relative request URI using the default host and port, the specified headers and the specified version of WebSockets

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version

    - #### WebSocketStream websocketStream(java.lang.String requestURI, MultiMap headers, io.vertx.core.http.WebsocketVersion version, java.lang.String subProtocols)

      Create a WebSocket stream at the relative request URI using the default host and port, the specified headers, the specified version of WebSockets and the specified sub protocols

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `requestURI` - the relative URI
        `headers` - the headers
        `version` - the websocket version
        `subProtocols` - the subprotocols